from __future__ import annotations
import mrc.benchmarking.watchers
import typing
import mrc.core.executor
import mrc.core.segment

__all__ = [
    "LatencyTracer",
    "LatencyWatcher",
    "ThroughputTracer",
    "ThroughputWatcher",
    "get_tracing_stats",
    "reset_tracing_stats",
    "sync_tracing_state",
    "trace_channels",
    "trace_operators"
]


class LatencyTracer():
    def __init__(self, arg0: int) -> None: ...
    @staticmethod
    def aggregate(arg0: object, arg1: list) -> None: ...
    def emit(self, arg0: int) -> None: ...
    pass
class LatencyWatcher():
    @typing.overload
    def __init__(self, arg0: mrc.core.executor.Executor) -> None: ...
    @typing.overload
    def __init__(self, arg0: mrc.core.executor.Executor, arg1: typing.Callable[[LatencyTracer], None]) -> None: ...
    def aggregate_tracers(self) -> dict: ...
    def is_running(self) -> bool: ...
    def make_segment(self, arg0: str, arg1: typing.Callable[[mrc.core.segment.Builder, LatencyWatcher], None]) -> None: ...
    def make_traced_node(self, arg0: mrc.core.segment.Builder, arg1: str, arg2: typing.Callable[[object], object]) -> mrc.core.segment.SegmentObject: ...
    def make_tracer_sink(self, arg0: mrc.core.segment.Builder, arg1: str, arg2: typing.Callable[[object], None]) -> mrc.core.segment.SegmentObject: ...
    def make_tracer_source(self, arg0: mrc.core.segment.Builder, arg1: str, arg2: bool) -> mrc.core.segment.SegmentObject: ...
    def reset(self) -> None: ...
    def run(self) -> None: ...
    def shutdown(self) -> None: ...
    def start_trace(self, arg0: bool) -> None: ...
    def stop_trace(self) -> None: ...
    def trace_until_notified(self) -> None: ...
    def tracer_count(self, arg0: int) -> None: ...
    def tracing(self) -> bool: ...
    pass
class ThroughputTracer():
    def __init__(self, arg0: int) -> None: ...
    pass
class ThroughputWatcher():
    @typing.overload
    def __init__(self, arg0: mrc.core.executor.Executor) -> None: ...
    @typing.overload
    def __init__(self, arg0: mrc.core.executor.Executor, arg1: typing.Callable[[ThroughputTracer], None]) -> None: ...
    def aggregate_tracers(self) -> dict: ...
    def is_running(self) -> bool: ...
    def make_segment(self, arg0: str, arg1: typing.Callable[[mrc.core.segment.Builder, ThroughputWatcher], None]) -> None: ...
    def make_traced_node(self, arg0: mrc.core.segment.Builder, arg1: str, arg2: typing.Callable[[object], object]) -> mrc.core.segment.SegmentObject: ...
    def make_tracer_sink(self, arg0: mrc.core.segment.Builder, arg1: str, arg2: typing.Callable[[object], None]) -> mrc.core.segment.SegmentObject: ...
    def make_tracer_source(self, arg0: mrc.core.segment.Builder, arg1: str, arg2: bool) -> mrc.core.segment.SegmentObject: ...
    def reset(self) -> None: ...
    def run(self) -> None: ...
    def shutdown(self) -> None: ...
    def start_trace(self, arg0: bool) -> None: ...
    def stop_trace(self) -> None: ...
    def trace_until_notified(self) -> None: ...
    def tracer_count(self, arg0: int) -> None: ...
    def tracing(self) -> bool: ...
    pass
def get_tracing_stats() -> object:
    pass
def reset_tracing_stats() -> None:
    pass
def sync_tracing_state() -> None:
    pass
@typing.overload
def trace_channels() -> typing.Tuple[bool, bool]:
    pass
@typing.overload
def trace_channels(trace: bool, sync_immediate: bool = True) -> None:
    pass
@typing.overload
def trace_operators() -> typing.Tuple[bool, bool]:
    pass
@typing.overload
def trace_operators(trace: bool, sync_immediate: bool = True) -> None:
    pass
