"""
        Python bindings for MRC executors
        -------------------------------
        .. currentmodule:: executor
        .. autosummary::
           :toctree: _generate
    """
from __future__ import annotations
import mrc.core.executor
import typing
import mrc.core.common
import mrc.core.options
import mrc.core.pipeline

__all__ = [
    "Awaitable",
    "Executor",
    "Future"
]


class Awaitable():
    def __await__(self) -> Awaitable: ...
    def __init__(self) -> None: ...
    def __iter__(self) -> Awaitable: ...
    def __next__(self) -> None: ...
    pass
class Executor():
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, arg0: mrc.core.options.Options) -> None: ...
    def join(self) -> None: ...
    def join_async(self) -> Awaitable: ...
    def register_pipeline(self, arg0: mrc.core.pipeline.Pipeline) -> None: ...
    def start(self) -> None: ...
    def stop(self) -> None: ...
    pass
class Future():
    def __init__(self) -> None: ...
    def result(self) -> object: ...
    def set_result(self, arg0: object) -> None: ...
    pass
__version__ = '23.11.0'
