"""
        Python bindings for MRC options
        -------------------------------
        .. currentmodule:: options
        .. autosummary::
           :toctree: _generate
    """
from __future__ import annotations
import mrc.core.options
import typing
import mrc.core.common

__all__ = [
    "Config",
    "EngineFactoryOptions",
    "EngineGroups",
    "EngineType",
    "Fiber",
    "Options",
    "PerMachine",
    "PerNumaNode",
    "PlacementOptions",
    "PlacementStrategy",
    "Process",
    "Thread",
    "TopologyOptions"
]


class Config():
    default_channel_size = 128
    pass
class EngineFactoryOptions():
    def __init__(self) -> None: ...
    @property
    def allow_overlap(self) -> bool:
        """
        :type: bool
        """
    @allow_overlap.setter
    def allow_overlap(self, arg1: bool) -> None:
        pass
    @property
    def cpu_count(self) -> int:
        """
        :type: int
        """
    @cpu_count.setter
    def cpu_count(self, arg1: int) -> None:
        pass
    @property
    def engine_type(self) -> EngineType:
        """
        :type: EngineType
        """
    @engine_type.setter
    def engine_type(self, arg1: EngineType) -> None:
        pass
    @property
    def reusable(self) -> bool:
        """
        :type: bool
        """
    @reusable.setter
    def reusable(self, arg1: bool) -> None:
        pass
    pass
class EngineGroups():
    def __init__(self) -> None: ...
    def engine_group_options(self, arg0: str) -> EngineFactoryOptions: ...
    def set_engine_factory_options(self, arg0: str, arg1: EngineFactoryOptions) -> None: ...
    @property
    def dedicated_main_thread(self) -> bool:
        """
        :type: bool
        """
    @dedicated_main_thread.setter
    def dedicated_main_thread(self, arg1: bool) -> None:
        pass
    @property
    def default_engine_type(self) -> EngineType:
        """
        :type: EngineType
        """
    @default_engine_type.setter
    def default_engine_type(self, arg1: EngineType) -> None:
        pass
    pass
class EngineType():
    """
    Members:

      Fiber

      Process

      Thread
    """
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __init__(self, value: int) -> None: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __repr__(self) -> str: ...
    def __setstate__(self, state: int) -> None: ...
    @property
    def name(self) -> str:
        """
        :type: str
        """
    @property
    def value(self) -> int:
        """
        :type: int
        """
    Fiber: mrc.core.options.EngineType # value = <EngineType.Fiber: 0>
    Process: mrc.core.options.EngineType # value = <EngineType.Process: 2>
    Thread: mrc.core.options.EngineType # value = <EngineType.Thread: 1>
    __members__: dict # value = {'Fiber': <EngineType.Fiber: 0>, 'Process': <EngineType.Process: 2>, 'Thread': <EngineType.Thread: 1>}
    pass
class Options():
    def __init__(self) -> None: ...
    @property
    def architect_url(self) -> str:
        """
        :type: str
        """
    @architect_url.setter
    def architect_url(self, arg1: str) -> None:
        pass
    @property
    def engine_factories(self) -> EngineGroups:
        """
        :type: EngineGroups
        """
    @property
    def placement(self) -> PlacementOptions:
        """
        :type: PlacementOptions
        """
    @property
    def topology(self) -> TopologyOptions:
        """
        :type: TopologyOptions
        """
    pass
class PlacementOptions():
    def __init__(self) -> None: ...
    @property
    def cpu_strategy(self) -> PlacementStrategy:
        """
        :type: PlacementStrategy
        """
    @cpu_strategy.setter
    def cpu_strategy(self, arg1: PlacementStrategy) -> None:
        pass
    pass
class PlacementStrategy():
    """
    Members:

      PerMachine

      PerNumaNode
    """
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __init__(self, value: int) -> None: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __repr__(self) -> str: ...
    def __setstate__(self, state: int) -> None: ...
    @property
    def name(self) -> str:
        """
        :type: str
        """
    @property
    def value(self) -> int:
        """
        :type: int
        """
    PerMachine: mrc.core.options.PlacementStrategy # value = <PlacementStrategy.PerMachine: 0>
    PerNumaNode: mrc.core.options.PlacementStrategy # value = <PlacementStrategy.PerNumaNode: 2>
    __members__: dict # value = {'PerMachine': <PlacementStrategy.PerMachine: 0>, 'PerNumaNode': <PlacementStrategy.PerNumaNode: 2>}
    pass
class TopologyOptions():
    def __init__(self) -> None: ...
    @property
    def user_cpuset(self) -> str:
        """
        :type: str
        """
    @user_cpuset.setter
    def user_cpuset(self, arg1: str) -> None:
        pass
    pass
Fiber: mrc.core.options.EngineType # value = <EngineType.Fiber: 0>
PerMachine: mrc.core.options.PlacementStrategy # value = <PlacementStrategy.PerMachine: 0>
PerNumaNode: mrc.core.options.PlacementStrategy # value = <PlacementStrategy.PerNumaNode: 2>
Process: mrc.core.options.EngineType # value = <EngineType.Process: 2>
Thread: mrc.core.options.EngineType # value = <EngineType.Thread: 1>
__version__ = '23.11.0'
